#include <allinc.h>
#include <apvector.h>
int noteStream[32]; // arrow buffer
double addNoteStream(int noteType); //factors in 'tech'
apstring dir; //body position, for determining crossovers.
apstring face; //N = north, forward; S = south, away. W or E => N.
int movingfoot; //0=left 1=right (1-value) to change
// values:
// LR
// UL
// UR
// DL
// DR
// UD* W/E counted as N.
void mainA (apstring command);
void mainB (apstring command);
void preparelistA(apstring readfile);
void evaluateA(apstring command);
void preparelistB(apstring readfile);
void evaluateB(apstring command);
inline double hyper(double x) {return sqrt(10000+x*x);}; //adjusts for quick stuff
apstring displayvalue(double value);
void main()
{
	apstring command;
	cout<<"DDR Difficulty Evaluator v.7B (c) Taren N."<<endl
   	 <<"            http://www.angelfire.com/ex/ddr1/"<<endl;
	cout<<"Enter command file to begin : ";
   getline(cin,command);
   mainA(command);//normal ranking
   mainB(command);//wild ranking
}
void mainA(apstring command)
{
	preparelistA(command);
   evaluateA(command);
}
void mainB(apstring command)
{
	preparelistB(command);
   evaluateB(command);
}
void evaluateA(apstring command)
{
	movingfoot=0;
   dir="LR"; face="N";
	int val [8] = { 4, 5, 6, 9, 11, 13, 1, 2};
	apstring filename;
   double currenttempo;
   apvector <double> tempo (0,0);
   apvector <apstring> set (0); //filename hitlist
   apvector <long double> ratings (0); //file ratings
   apvector <apstring> songtitle(0); //songtitles
   apvector <apstring> feet(0);
   apvector <int> tech(0);
   ofstream ouf;

   apstring temporaryfilename="SORTED7B"+command;
   ouf.open(temporaryfilename.c_str());
   ifstream inf;
   inf.open(command.c_str());
   if (inf.fail())
   {
   	cout<<"File not found!"; getch(); abort();
   }
   do
   {
      getline(inf,filename);
      set.resize(set.length()+5);
      ratings.resize(set.length());
      set[set.length()-5]=filename+".beginner.ddr";
      set[set.length()-4]=filename+".basic.ddr";
      set[set.length()-3]=filename+".another.ddr";
      set[set.length()-2]=filename+".maniac.ddr";
      set[set.length()-1]=filename+".smaniac.ddr";
      songtitle.resize(songtitle.length()+5);
	   feet.resize(feet.length()+5);
      tech.resize(tech.length()+5);
   }while(!inf.eof());
   inf.close();
   for(int i=0; i<tech.length(); i++)
   	tech[i]=0;
   for(int iteration=0; iteration<set.length(); iteration++)
	{
      bool begin=false;
	   long double tyme=0.00000001, buffer=0;
	   long double score=0, scoreadd=0;
      filename=set[iteration];
		ifstream inf;
	   inf.open(filename.c_str());
      if (inf.fail())
      {
      	cout<<"File "<<filename<<" failed!";
         getch(); abort();
      }
	if (!inf.fail())
   {
   	cout<<set[iteration]<<" did not fail"<<endl; //getch();
      apstring songname;
      getline(inf,songname);
      inf>>feet[iteration];
      switch(iteration%5)
      {
      	case 0: songtitle[iteration]=songname+".BEGIN"; break;
         case 1: songtitle[iteration]=songname+".LIGHT"; break;
         case 2: songtitle[iteration]=songname+".STDRD"; break;
         case 3: songtitle[iteration]=songname+".HEAVY"; break;
         case 4: songtitle[iteration]=songname+".CHLNG"; break;
      };

	   double step=8, pos=0, lastpos=0, lastposactive=0; //in case of [triplets]
	   										//step between positions, position is loc in file
	   char ch;
	   bool kosher;
	   bool h4=false, h2=false, h8=false, h6=false; //held arrows, to negate doubling freezes

      tempo.resize(0);
      double value;
      do
      {
      	inf>>value;
         if (value!=9999) //9999 quits tempochange/freeze section
         {
         	if (value==8888) //8888 defines freeze
            {
            	inf>>value;
               tyme+=value;
            }
            else
            {
            	tempo.resize(tempo.length()+2);
               tempo[tempo.length()-2]=value*4; //position , tempo
               inf>>value;
               tempo[tempo.length()-1]=value;
            }
         }
      }while (value!=9999 && !inf.eof());
      if (tempo.length()==0)
      {
      	cout<<"Tempo definition missing from "<<filename<<"!";
         getch(); abort();
      }
	   do
	   {
      	int highest=-1; //makes sure that outoforder TC's don't override real tempo
      	for(int k=0; k<tempo.length(); k+=2)
         {
         	if (pos>=tempo[k] && tempo[k]>=highest)
            {
            	highest=tempo[k];
            	currenttempo=tempo[k+1];
            }
         }
	   	inf>>ch;
	      if (inf.eof())
	      	ch='0';
	      kosher=false; //weeds out undefined chars

	      //weeding out freeze-kills
	      if (ch=='1')
	      {
	      	if (h4 && !h2)
	         	ch='2';
	         if (!h4 && h2)
	         	ch='4';
	         if (h4 && h2)
	         	ch='0';
	         h4=false; h2=false;
	      }
	      if (ch=='2')
	      {
	      	if (h2)
	         	ch='0';
	         h2=false;
	      }
	      if (ch=='3')
	      {
	   		if (h2 && !h6)
	         	ch='6';
	         if (!h2 && h6)
	         	ch='2';
	         if (h2 && h6)
	         	ch='0';
	         h2=false; h6=false;
	      }
	      if (ch=='4')
	      {
	      	if (h4)
	         	ch='0';
	         h4=false;
	      }
	      if (ch=='6')
	      {
	      	if (h6)
	         	ch='0';
	         h6=false;
	      }
	      if (ch=='7')
	      {
	      	if (h4 && !h8)
	         	ch='8';
	         if (!h4 && h8)
	         	ch='4';
	         if (h4 && h8)
	         	ch='0';
	         h4=false; h8=false;
	      }
	      if (ch=='8')
	      {
	      	if (h8)
	         	ch='0';
	         h8=false;
	      }
	      if (ch=='9')
	      {
	      	if (h8 && !h6)
	         	ch='6';
	         if (!h8 && h6)
	         	ch='8';
	         if (h8 && h6)
	         	ch='0';
	         h8=false; h6=false;
	      }
	      if (ch=='A')
   	   {
	      	if (h2 && !h8)
	         	ch='8';
	         if (!h2 && h8)
	         	ch='2';
	         if (h2 && h8)
	         	ch='0';
	         h2=false; h8=false;
	      }
	      if (ch=='B')
	      {
	      	if (h4 && !h6)
	         	ch='6';
	         if (!h4 && h6)
	         	ch='4';
	         if (h4 && h6)
	         	ch='0';
	         h4=false; h6=false;
	      }

	      if (ch=='(')
	      {
	      	pos-=step;
	      	step=4;
	         kosher=true;
	      }
	      if (ch=='[')
	      {
	         pos-=step;
	      	step=2.66666666667;
	         kosher=true;
	      }
	      if (ch=='{')
	      {
	         pos-=step;
	      	step=1;
	         kosher=true;
	      }
	      if (ch==')' || ch==']' || ch=='}')
	      {
	         pos-=step;
	      	step=8;
	         kosher=true;
	      }
         if (ch=='<')
         {
         	cout<<endl<<endl<<" <> type notes not allowed. Aborting.";
            getch(); abort();
         }
	      if (ch=='!')
	      {
	      	pos-=step;
	         inf>>ch; //dummy val, get rid of 'held' char
	         switch(ch)
	         {
	         	case '4': h4=true; break;
	            case '2': h2=true; break;
	            case '8': h8=true; break;
	            case '6': h6=true; break;
	            case '1': h4=true; h2=true; break;
	            case '3': h2=true; h6=true; break;
	            case '7': h4=true; h8=true; break;
	            case '9': h8=true; h6=true; break;
	            case 'A': h2=true; h8=true; break;
	            case 'B': h4=true; h6=true; break;
	         };
	         kosher=true;
	         scoreadd=val[0]; //1
	      }
	      if (!kosher) //see two lines up, skips if ! is found
	      {
		      if (ch=='1' || ch=='3' || ch=='7' || ch=='9' || ch=='A' || ch=='B')
		      {
		         kosher=true;
	            if (int(pos)%8==0)
	            	scoreadd=val[4]; //5
	         	else if (int(pos)%8==4)
	            	scoreadd=val[5];   //7
	            else
	            	scoreadd=val[6];//11
               begin=true;
		      }
		      if (ch=='2' || ch=='4' || ch=='6' || ch=='8')
		      {
		         kosher=true;
	            if (int(pos)%8==0)
	            	scoreadd=val[1]; //2
	         	else if (int(pos)%8==4)
	            	scoreadd=val[2];    //3
	            else
	            	scoreadd=val[3];       //5
	            if (h2 || h4 || h6 || h8)
	            	scoreadd*=val[7];
               begin=true;
		      }
		      if (ch=='0')
		      	kosher=true;
	      }
	      if (kosher) //makes sure char is not a bogus char
         {
         	if (begin && ((ch>='0' && ch<='9') || ch=='A' || ch=='B'))
            {
	         	buffer+=60000.0/((16.0/step)*currenttempo);
               if (buffer>2000 && !h2 && !h4 && !h6 && !h8) //time in ms
               {
               	dir="LR";
                  face="N"; //reset direction
               }
            }
		      pos+=step;
            if ((ch>='1' && ch<='9') || ch=='A' || ch=='B')
            {
            	scoreadd*=250/hyper(buffer);
            	tyme+=buffer;
               buffer=0;
            }
         }
         if ((ch>='1' && ch<='9') || ch=='A' || ch=='B')
         {
         	double tempJ=addNoteStream(int(ch)-48);
         	if (tempJ>1)
               tech[iteration]++;
		   	score+=scoreadd*tempJ; //multiply by 10 for 'tech found'
	      	scoreadd=0;
      	}
	   }while (!inf.eof());
	   ratings[iteration]=score*90000/tyme; //time normalized to 90 sec.
      cout<<ratings[iteration]<<" points"<<endl; //getch();
      cout<<filename<<" is "<<tyme/1000<<" sec. long. Begin:"<<begin<<endl;
      cout<<set[iteration]<<" completed"<<endl; //getch();
   }
   }
   int index;
	for(int i=0; i<set.length(); i++)
   {
   	index=i;
   	for(int j=i; j<set.length(); j++)
      	if (ratings[index]<ratings[j])
         	index=j;
      long double temp=ratings[i];
      ratings[i]=ratings[index];
      ratings[index]=temp;
      apstring temps=set[i];
      set[i]=set[index];
      set[index]=temps;
      apstring tempname=songtitle[i];
      songtitle[i]=songtitle[index];
      songtitle[index]=tempname;
      apstring tempfeet=feet[i];
      feet[i]=feet[index];
      feet[index]=tempfeet;
      int temptech=tech[i];
      tech[i]=tech[index];
      tech[index]=temptech;
      if (ratings[i]!=0)
      {
	      cout<<setw(40)<<songtitle[i]<<" / "<<setw(4)<<i+1<<" / "<<setw(4)<<setprecision(6)<<ratings[i]<<" / "<<feet[i]<<endl;
	       ouf<<setw(40)<<songtitle[i]<<" / "<<setw(4)<<i+1<<" / "<<setw(4)<<displayvalue(ratings[i])<<" / "<<setw(2)<<feet[i]<<" / "<<tech[i]<<endl;
      }
   }
   cout<<"DONE";
	//getch();
   inf.close();
   ouf.close();
}
















void preparelistA(apstring readfile)
{
	apstring getfile, putfile; //read names, get files, write file
   apvector <apstring> hitlist(0); //list of songnames read from file
   apvector <apstring> outlist(0);
   ifstream inf;
   inf.open(readfile.c_str());
   if (inf.fail())
   {
   	cout<<readfile<<" does not exist. Program will now terminate.";
      getch(); abort();
   }
   while(!inf.eof())
   {
		getline(inf, getfile); //get file name
      hitlist.resize(hitlist.length()+1);
      hitlist[hitlist.length()-1]=getfile+".dwi"; //increase length, enter value
      outlist.resize(hitlist.length()+1);
      outlist[hitlist.length()-1]=getfile; //increase length, enter value
   }
   inf.close();
   for(int i=0; i<hitlist.length(); i++)
   {
	   char ch;
	   apstring temp; //goes from here to...
	   apstring title="", beginner="", basic="", another="", maniac="", smaniac="";
      apvector <apstring> feet(5," ");
      apstring tempo="0 ";
   	inf.open(hitlist[i].c_str());
      while(!inf.eof())
		{
      	temp="";
      	inf>>ch;
	      bool pound=false;
         apstring dummy;
	      do
	      {
	      	if (ch=='#') pound=true;
				if (pound)
		      	temp=temp+ch;
	         inf>>ch;
	         if (ch=='/')
	         {
	         	inf>>ch;
	            if (ch=='/')
	            	getline(inf,dummy); //eats up comments
	         }
	         if (pound && ch=='#')
	         {
	         	cout<<"There is a problem with "<<hitlist[i]<<". Aborting...";
	            getch();
	            abort();
	         }//prevents runon lines
	      }while(ch!=';');

	      if (temp.length()>5)
			{
         	if (temp[1]=='T' && temp[2]=='I' && temp[3]=='T' && temp[4]=='L' && temp[5]=='E')
		      	for(int j=7; j<temp.length(); j++)
               {
		         	title=title+temp[j];
                  if (j==40) j=temp.length();
               }
		      if (temp[1]=='B' && temp[2]=='P' && temp[3]=='M')
            {
		      	for(int j=5; j<temp.length(); j++)
		         	tempo=tempo+temp[j];
               tempo=tempo+" ";
            }
		      if (temp[1]=='F' && temp[2]=='R' && temp[3]=='E')
		      {
		      	bool deleter=true;
		         tempo=tempo+" 8888 ";
		      	for(int j=8; j<temp.length(); j++)
		         {
		         	if (temp[j]=='=')
		            	deleter=false;
		            if (temp[j]==',')
		            {
		            	deleter=true;
		               tempo=tempo+" 8888 "; //works with multiple freezes
		            }
		            if (!deleter && temp[j]!='=')
				         tempo=tempo+temp[j];
		         }
               tempo=tempo+" ";
		      }
		      if (temp[1]=='C' && temp[2]=='H' && temp[3]=='A')
		      	for(int j=11; j<temp.length(); j++)
		            if (temp[j]!='=' && temp[j]!=',')
				         tempo=tempo+temp[j];
		            else
		            	tempo=tempo+" ";
	         if (temp.length()>19)
	         {
			      if (temp[1]=='S' && temp[12]=='N')//begiNner  singles...
			      {
               	for(int j=19; j<temp.length(); j++)
			         	beginner=beginner+temp[j];
                  feet[0]=temp[17];
                  if (temp[18]!=':')
                  	feet[0]=feet[0]+temp[18];
               }
			      if (temp[1]=='S' && temp[12]=='C')//basiC
               {
			      	for(int j=16; j<temp.length(); j++)
			         	basic=basic+temp[j];
                  feet[1]=temp[14];
                  if (temp[15]!=':')
                  	feet[1]=feet[1]+temp[15];
               }
			      if (temp[1]=='S' && temp[12]=='H')//anotHer
               {
			      	for(int j=18; j<temp.length(); j++)
			         	another=another+temp[j];
                  feet[2]=temp[16];
                  if (temp[17]!=':')
                  	feet[2]=feet[2]+temp[17];
               }
			      if (temp[1]=='S' && temp[12]=='A')//maniAc
               {
			      	for(int j=17; j<temp.length(); j++)
			         	maniac=maniac+temp[j];
                  feet[3]=temp[15];
                  if (temp[16]!=':')
                  	feet[3]=feet[3]+temp[16];
               }
			      if (temp[1]=='S' && temp[12]=='I')//smanIac
			      {
               	for(int j=18; j<temp.length(); j++)
		      	   	smaniac=smaniac+temp[j];
                  feet[4]=temp[16];
                  if (temp[17]!=':')
                  	feet[4]=feet[4]+temp[17];
               }
	         }
         }
      }
      tempo+=" 9999";
      apstring tempA=outlist[i]+".beginner.ddr";
      apstring tempB=outlist[i]+".basic.ddr";
      apstring tempC=outlist[i]+".another.ddr";
      apstring tempD=outlist[i]+".maniac.ddr";
      apstring tempE=outlist[i]+".smaniac.ddr";
      ofstream ouf;
      if (tempA=="")
      	tempA="0";
      if (tempB=="")
      	tempB="0";
      if (tempC=="")
      	tempC="0";
      if (tempD=="")
      	tempD="0";
      if (tempE=="")
      	tempE="0";
         ouf.open(tempA.c_str());
      	ouf<<title<<endl<<feet[0]<<endl<<tempo<<endl<<beginner;
         ouf.close();
         ouf.open(tempB.c_str());
      	ouf<<title<<endl<<feet[1]<<endl<<tempo<<endl<<basic;
         ouf.close();
         ouf.open(tempC.c_str());
      	ouf<<title<<endl<<feet[2]<<endl<<tempo<<endl<<another;
         ouf.close();
         ouf.open(tempD.c_str());
      	ouf<<title<<endl<<feet[3]<<endl<<tempo<<endl<<maniac;
         ouf.close();
         ouf.open(tempE.c_str());
      	ouf<<title<<endl<<feet[4]<<endl<<tempo<<endl<<smaniac;
         ouf.close();
      inf.close();
      cout<<"Completed ["<<outlist[i]<<"] ("<<setw(3)<<i+1<<"/"<<setw(3)<<outlist.length()-1<<")"<<endl;
   }
   cout<<"DONE";
}



















void evaluateB(apstring command)
{
	movingfoot=0;
   dir="LR"; face="N";
	int val [8] = { 4, 5, 6, 9, 11, 13, 1, 2};
	apstring filename;
   double currenttempo;
   apvector <double> tempo (0,0);
   apvector <apstring> set (0); //filename hitlist
   apvector <long double> ratings (0); //file ratings
   apvector <apstring> songtitle(0); //songtitles
   apvector <int> feet(0);
   apvector <int> tech(0);
   ofstream ouf;

   apstring temporaryfilename="SORTED7BWILD"+command;
   ouf.open(temporaryfilename.c_str());
   ifstream inf;
   inf.open(command.c_str());
   if (inf.fail())
   {
   	cout<<"File not found!"; getch(); abort();
   }
   do
   {
      getline(inf,filename);
      set.resize(set.length()+5);
      ratings.resize(set.length());
      set[set.length()-5]=filename+".beginner.ddr";
      set[set.length()-4]=filename+".basic.ddr";
      set[set.length()-3]=filename+".another.ddr";
      set[set.length()-2]=filename+".maniac.ddr";
      set[set.length()-1]=filename+".smaniac.ddr";
      songtitle.resize(songtitle.length()+5);
      feet.resize(feet.length()+5);
      tech.resize(tech.length()+5);
   }while(!inf.eof());
   inf.close();
   for(int i=0; i<tech.length(); i++)
   	tech[i]=0;
   for(int iteration=0; iteration<set.length(); iteration++)
	{
      bool begin=false;
	   long double tyme=0.0000001, buffer=0;
	   long double score=0, scoreadd=0;
      filename=set[iteration];
		ifstream inf;
	   inf.open(filename.c_str());
      if (inf.fail())
      {
      	cout<<"File "<<filename<<" failed!";
         getch(); abort();
      }
	if (!inf.fail())
   {
   	cout<<set[iteration]<<" did not fail"<<endl; //getch();
      apstring songname;
      getline(inf,songname);
      inf>>feet[iteration];
      switch(iteration%5)
      {
      	case 0: songtitle[iteration]=songname+".BEGIN"; break;
         case 1: songtitle[iteration]=songname+".LIGHT"; break;
         case 2: songtitle[iteration]=songname+".STDRD"; break;
         case 3: songtitle[iteration]=songname+".HEAVY"; break;
         case 4: songtitle[iteration]=songname+".CHLNG"; break;
      };

	   double step=8, pos=0, lastpos=0, lastposactive=0; //in case of [triplets]
	   										//step between positions, position is loc in file
	   char ch;
	   bool kosher;
	   bool h4=false, h2=false, h8=false, h6=false; //held arrows, to negate doubling freezes

      tempo.resize(0);
      double value;
      do
      {
      	inf>>value;
         if (value!=9999) //9999 quits tempochange/freeze section
         {
         	if (value==8888) //8888 defines freeze
            {
            	inf>>value;
               tyme+=value;
            }
            else
            {
            	tempo.resize(tempo.length()+2);
               tempo[tempo.length()-2]=value*4; //position , tempo
               inf>>value;
               tempo[tempo.length()-1]=value;
            }
         }
      }while (value!=9999 && !inf.eof());
      if (tempo.length()==0)
      {
      	cout<<"Tempo definition missing from "<<filename<<"!";
         getch(); abort();
      }
	   do
	   {
      	int highest=-1; //makes sure that outoforder TC's don't override real tempo
      	for(int k=0; k<tempo.length(); k+=2)
         {
         	if (pos>=tempo[k] && tempo[k]>=highest)
            {
            	highest=tempo[k];
            	currenttempo=tempo[k+1];
            }
         }
	   	inf>>ch;
	      if (inf.eof())
	      	ch='0';
	      kosher=false; //weeds out undefined chars

	      //weeding out freeze-kills
	      if (ch=='1')
	      {
	      	if (h4 && !h2)
	         	ch='2';
	         if (!h4 && h2)
	         	ch='4';
	         if (h4 && h2)
	         	ch='0';
	         h4=false; h2=false;
	      }
	      if (ch=='2')
	      {
	      	if (h2)
	         	ch='0';
	         h2=false;
	      }
	      if (ch=='3')
	      {
	   		if (h2 && !h6)
	         	ch='6';
	         if (!h2 && h6)
	         	ch='2';
	         if (h2 && h6)
	         	ch='0';
	         h2=false; h6=false;
	      }
	      if (ch=='4')
	      {
	      	if (h4)
	         	ch='0';
	         h4=false;
	      }
	      if (ch=='6')
	      {
	      	if (h6)
	         	ch='0';
	         h6=false;
	      }
	      if (ch=='7')
	      {
	      	if (h4 && !h8)
	         	ch='8';
	         if (!h4 && h8)
	         	ch='4';
	         if (h4 && h8)
	         	ch='0';
	         h4=false; h8=false;
	      }
	      if (ch=='8')
	      {
	      	if (h8)
	         	ch='0';
	         h8=false;
	      }
	      if (ch=='9')
	      {
	      	if (h8 && !h6)
	         	ch='6';
	         if (!h8 && h6)
	         	ch='8';
	         if (h8 && h6)
	         	ch='0';
	         h8=false; h6=false;
	      }
	      if (ch=='A')
   	   {
	      	if (h2 && !h8)
	         	ch='8';
	         if (!h2 && h8)
	         	ch='2';
	         if (h2 && h8)
	         	ch='0';
	         h2=false; h8=false;
	      }
	      if (ch=='B')
	      {
	      	if (h4 && !h6)
	         	ch='6';
	         if (!h4 && h6)
	         	ch='4';
	         if (h4 && h6)
	         	ch='0';
	         h4=false; h6=false;
	      }

	      if (ch=='(')
	      {
	      	pos-=step;
	      	step=4;
	         kosher=true;
	      }
	      if (ch=='[')
	      {
	         pos-=step;
	      	step=2.66666666667;
	         kosher=true;
	      }
	      if (ch=='{')
	      {
	         pos-=step;
	      	step=1;
	         kosher=true;
	      }
	      if (ch==')' || ch==']' || ch=='}')
	      {
	         pos-=step;
	      	step=8;
	         kosher=true;
	      }
	      if (ch=='!')
	      {
	      	pos-=step;
	         inf>>ch; //dummy val, get rid of 'held' char
	         switch(ch)
	         {
	         	case '4': h4=true; break;
	            case '2': h2=true; break;
	            case '8': h8=true; break;
	            case '6': h6=true; break;
	            case '1': h4=true; h2=true; break;
	            case '3': h2=true; h6=true; break;
	            case '7': h4=true; h8=true; break;
	            case '9': h8=true; h6=true; break;
	            case 'A': h2=true; h8=true; break;
	            case 'B': h4=true; h6=true; break;
	         };
	         kosher=true;
	         scoreadd=val[0]; //1
	      }
	      if (!kosher) //see two lines up, skips if ! is found
	      {
		      if (ch=='1' || ch=='3' || ch=='7' || ch=='9' || ch=='A' || ch=='B')
		      {
		         kosher=true;
	            if (int(pos)%8==0)
	            	scoreadd=val[4]; //5
	         	else if (int(pos)%8==4)
	            	scoreadd=val[5];   //7
	            else
	            	scoreadd=val[6];//11
               begin=true;
		      }
		      if (ch=='2' || ch=='4' || ch=='6' || ch=='8')
		      {
		         kosher=true;
	            if (int(pos)%8==0)
	            	scoreadd=val[1]; //2
	         	else if (int(pos)%8==4)
	            	scoreadd=val[2];    //3
	            else
	            	scoreadd=val[3];       //5
	            if (h2 || h4 || h6 || h8)
	            	scoreadd*=val[7];
               begin=true;
		      }
		      if (ch=='0')
		      	kosher=true;
	      }
	      if (kosher) //makes sure char is not a bogus char
         {
         	if (begin && ((ch>='0' && ch<='9') || ch=='A' || ch=='B'))
            {
	         	buffer+=60000.0/((16.0/step)*currenttempo);
               if (buffer>2000 && !h2 && !h4 && !h6 && !h8) //time in ms
               {
               	dir="LR";
                  face="N"; //reset direction
               }
            }
		      pos+=step;
            if ((ch>='1' && ch<='9') || ch=='A' || ch=='B')
            {
            	scoreadd*=250/hyper(buffer);
            	tyme+=buffer;
               buffer=0;
            }
         }
         if ((ch>='1' && ch<='9') || ch=='A' || ch=='B')
         {
         	double tempJ=addNoteStream(int(ch)-48);
         	if (tempJ>1)
               tech[iteration]++;
		   	score+=scoreadd*tempJ; //multiply by 10 for 'tech found'
	      	scoreadd=0;
      	}
	   }while (!inf.eof());
	   ratings[iteration]=score;//*90000/tyme; //time NOT normalized to 90 sec.
      cout<<ratings[iteration]<<" points"<<endl; //getch();
      cout<<filename<<" is "<<tyme/1000<<" sec. long. Begin:"<<begin<<endl;
      cout<<set[iteration]<<" completed"<<endl; //getch();
   }
   }
   int index;
	for(int i=0; i<set.length(); i++)
   {
   	index=i;
   	for(int j=i; j<set.length(); j++)
      	if (ratings[index]<ratings[j])
         	index=j;
      long double temp=ratings[i];
      ratings[i]=ratings[index];
      ratings[index]=temp;
      apstring temps=set[i];
      set[i]=set[index];
      set[index]=temps;
      apstring tempname=songtitle[i];
      songtitle[i]=songtitle[index];
      songtitle[index]=tempname;
      int tempfeet=feet[i];
      feet[i]=feet[index];
      feet[index]=tempfeet;
      int temptech=tech[i];
      tech[i]=tech[index];
      tech[index]=temptech;
      if (ratings[i]!=0)
      {
	      cout<<setw(40)<<songtitle[i]<<" / "<<setw(4)<<i+1<<" / "<<setw(4)<<setprecision(6)<<ratings[i]<<" / "<<feet[i]<<endl;
	       ouf<<setw(40)<<songtitle[i]<<" / "<<setw(4)<<i+1<<" / "<<setw(4)<<displayvalue(ratings[i])<<" / "<<setw(2)<<feet[i]<<" / "<<tech[i]<<endl;
      }
   }
   cout<<"DONE";
	//getch();
   inf.close();
   ouf.close();
}
















void preparelistB(apstring readfile)
{
	apstring getfile, putfile; //read names, get files, write file
   apvector <apstring> hitlist(0); //list of songnames read from file
   apvector <apstring> outlist(0);
   ifstream inf;
   inf.open(readfile.c_str());
   if (inf.fail())
   {
   	cout<<readfile<<" does not exist. Program will now terminate.";
      getch(); abort();
   }
   while(!inf.eof())
   {
		getline(inf, getfile); //get file name
      hitlist.resize(hitlist.length()+1);
      hitlist[hitlist.length()-1]=getfile+".dwi"; //increase length, enter value
      outlist.resize(hitlist.length()+1);
      outlist[hitlist.length()-1]=getfile; //increase length, enter value
   }
   inf.close();
   for(int i=0; i<hitlist.length(); i++)
   {
	   char ch;
	   apstring temp; //goes from here to...
	   apstring title="", beginner="", basic="", another="", maniac="", smaniac="";
      apvector <apstring> feet(5," ");
      apstring tempo="0 ";
   	inf.open(hitlist[i].c_str());
      while(!inf.eof())
		{
      	temp="";
      	inf>>ch;
	      bool pound=false;
         apstring dummy;
	      do
	      {
	      	if (ch=='#') pound=true;
				if (pound && ch!='/')
		      	temp=temp+ch;
	         inf>>ch;
	         if (ch=='/')
	         {
	         	inf>>ch;
	            if (ch=='/')
	            	getline(inf,dummy); //eats up comments
	         }
	         if (pound && ch=='#')
	         {
	         	cout<<"There is a problem with "<<hitlist[i]<<". Aborting...";
	            getch();
	            abort();
	         }//prevents runon lines
	      }while(ch!=';');

	      if (temp.length()>5)
			{
         	if (temp[1]=='T' && temp[2]=='I' && temp[3]=='T' && temp[4]=='L' && temp[5]=='E')
		      	for(int j=7; j<temp.length(); j++)
               {
		         	title=title+temp[j];
                  if (j==40) j=temp.length();
               }
		      if (temp[1]=='B' && temp[2]=='P' && temp[3]=='M')
            {
		      	for(int j=5; j<temp.length(); j++)
		         	tempo=tempo+temp[j];
               tempo=tempo+" ";
            }
		      if (temp[1]=='F' && temp[2]=='R' && temp[3]=='E')
		      {
		      	bool deleter=true;
		         tempo=tempo+" 8888 ";
		      	for(int j=8; j<temp.length(); j++)
		         {
		         	if (temp[j]=='=')
		            	deleter=false;
		            if (temp[j]==',')
		            {
		            	deleter=true;
		               tempo=tempo+" 8888 "; //works with multiple freezes
		            }
		            if (!deleter && temp[j]!='=')
				         tempo=tempo+temp[j];
		         }
               tempo=tempo+" ";
		      }
		      if (temp[1]=='C' && temp[2]=='H' && temp[3]=='A')
		      	for(int j=11; j<temp.length(); j++)
		            if (temp[j]!='=' && temp[j]!=',')
				         tempo=tempo+temp[j];
		            else
		            	tempo=tempo+" ";
	         if (temp.length()>19)
	         {
			      if (temp[1]=='S' && temp[12]=='N')//begiNner  singles...
			      {
               	for(int j=19; j<temp.length(); j++)
			         	beginner=beginner+temp[j];
                  feet[0]=temp[17];
                  if (temp[18]!=':')
                  	feet[0]=feet[0]+temp[18];
               }
			      if (temp[1]=='S' && temp[12]=='C')//basiC
               {
			      	for(int j=16; j<temp.length(); j++)
			         	basic=basic+temp[j];
                  feet[1]=temp[14];
                  if (temp[15]!=':')
                  	feet[1]=feet[1]+temp[15];
               }
			      if (temp[1]=='S' && temp[12]=='H')//anotHer
               {
			      	for(int j=18; j<temp.length(); j++)
			         	another=another+temp[j];
                  feet[2]=temp[16];
                  if (temp[17]!=':')
                  	feet[2]=feet[2]+temp[17];
               }
			      if (temp[1]=='S' && temp[12]=='A')//maniAc
               {
			      	for(int j=17; j<temp.length(); j++)
			         	maniac=maniac+temp[j];
                  feet[3]=temp[15];
                  if (temp[16]!=':')
                  	feet[3]=feet[3]+temp[16];
               }
			      if (temp[1]=='S' && temp[12]=='I')//smanIac
			      {
               	for(int j=18; j<temp.length(); j++)
		      	   	smaniac=smaniac+temp[j];
                  feet[4]=temp[16];
                  if (temp[17]!=':')
                  	feet[4]=feet[4]+temp[17];
               }
	         }
         }
      }
      tempo+=" 9999";
      apstring tempA=outlist[i]+".beginner.ddr";
      apstring tempB=outlist[i]+".basic.ddr";
      apstring tempC=outlist[i]+".another.ddr";
      apstring tempD=outlist[i]+".maniac.ddr";
      apstring tempE=outlist[i]+".smaniac.ddr";
      ofstream ouf;
      if (tempA=="")
      	tempA="0";
      if (tempB=="")
      	tempB="0";
      if (tempC=="")
      	tempC="0";
      if (tempD=="")
      	tempD="0";
      if (tempE=="")
      	tempE="0";
         ouf.open(tempA.c_str());
      	ouf<<title<<endl<<feet[0]<<endl<<tempo<<endl<<beginner;
         ouf.close();
         ouf.open(tempB.c_str());
      	ouf<<title<<endl<<feet[1]<<endl<<tempo<<endl<<basic;
         ouf.close();
         ouf.open(tempC.c_str());
      	ouf<<title<<endl<<feet[2]<<endl<<tempo<<endl<<another;
         ouf.close();
         ouf.open(tempD.c_str());
      	ouf<<title<<endl<<feet[3]<<endl<<tempo<<endl<<maniac;
         ouf.close();
         ouf.open(tempE.c_str());
      	ouf<<title<<endl<<feet[4]<<endl<<tempo<<endl<<smaniac;
         ouf.close();
      inf.close();
      cout<<"Completed ["<<outlist[i]<<"] ("<<setw(3)<<i+1<<"/"<<setw(3)<<outlist.length()-1<<")"<<endl;
   }
   cout<<"DONE";
}
apstring displayvalue(double value)
{
	apstring ret="";
   value/=100000;
	for(int i=1; i<=7; i++)
   {
   	value*=10;
      ret=ret+char(48+int(value)%10);
      if (i==5)
      	ret=ret+".";
   }
   return ret;
}

double addNoteStream(int noteType)
{
  	for(int x=24; x<32; x++)
  		noteStream[x-1]=noteStream[x];
	noteStream[31]=noteType;

//apstring dir; body position, for determining crossovers.
//apstring face; N = north, forward; S = south, away. W or E => N.
//int movingfoot; 0=left 1=right (1-value) to change
// values:
// LR
// UL
// UR
// DL
// DR
// UD* W/E counted as N.

// UD: WN = West coming from N,
//     WS =  "   coming from S,
//     EN = East coming from N,
//     ES =  "   coming from S.

   bool found=false;
	apstring olddir=dir;
	apstring newface; //if current face != newface then return tech
if (dir=="LR" && !movingfoot && face=="N" && noteType==1)	{found=true; newface="N"; dir="DL";}
if (dir=="LR" && !movingfoot && face=="N" && noteType==3)	{found=true; newface="N"; dir="DR";}
if (dir=="LR" && !movingfoot && face=="N" && noteType==7)	{found=true; newface="N"; dir="UL";}
if (dir=="LR" && !movingfoot && face=="N" && noteType==9)   {found=true; newface="N"; dir="UR";}
if (dir=="LR" && !movingfoot && face=="N" && noteType==17)	{found=true; newface="EN"; dir="UD";}
if (dir=="LR" && !movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="LR" && !movingfoot && face=="N" && noteType==2)	{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="LR" && !movingfoot && face=="N" && noteType==4)	{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && !movingfoot && face=="N" && noteType==6)	{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && !movingfoot && face=="N" && noteType==8)	{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="N" && noteType==1)		{found=true; newface="N"; dir="DL";}
if (dir=="LR" && movingfoot && face=="N" && noteType==3)		{found=true; newface="N"; dir="DR";}
if (dir=="LR" && movingfoot && face=="N" && noteType==7)		{found=true; newface="N"; dir="UL";}
if (dir=="LR" && movingfoot && face=="N" && noteType==9)	  	{found=true; newface="N"; dir="UR";}
if (dir=="LR" && movingfoot && face=="N" && noteType==17)  	{found=true; newface="EN"; dir="UD";}
if (dir=="LR" && movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="LR" && movingfoot && face=="N" && noteType==2)	  	{found=true; newface="N"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="N" && noteType==4)		{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="N" && noteType==6)		{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="N" && noteType==8)		{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="LR" && !movingfoot && face=="S" && noteType==1)	{found=true; newface="S"; dir="DL";}
if (dir=="LR" && !movingfoot && face=="S" && noteType==3)	{found=true; newface="S"; dir="DR";}
if (dir=="LR" && !movingfoot && face=="S" && noteType==7)	{found=true; newface="S"; dir="UL";}
if (dir=="LR" && !movingfoot && face=="S" && noteType==9)   {found=true; newface="S"; dir="UR";}
if (dir=="LR" && !movingfoot && face=="S" && noteType==17)	{found=true; newface="WS"; dir="UD";}
if (dir=="LR" && !movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="LR" && !movingfoot && face=="S" && noteType==2)	{found=true; newface="S"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="LR" && !movingfoot && face=="S" && noteType==4)	{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && !movingfoot && face=="S" && noteType==6)	{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && !movingfoot && face=="S" && noteType==8)	{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="S" && noteType==1)		{found=true; newface="S"; dir="DL";}
if (dir=="LR" && movingfoot && face=="S" && noteType==3)		{found=true; newface="S"; dir="DR";}
if (dir=="LR" && movingfoot && face=="S" && noteType==7)		{found=true; newface="S"; dir="UL";}
if (dir=="LR" && movingfoot && face=="S" && noteType==9)	  	{found=true; newface="S"; dir="UR";}
if (dir=="LR" && movingfoot && face=="S" && noteType==17)  	{found=true; newface="WS"; dir="UD";}
if (dir=="LR" && movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="LR" && movingfoot && face=="S" && noteType==2)	  	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="S" && noteType==4)		{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="S" && noteType==6)		{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="LR" && movingfoot && face=="S" && noteType==8)		{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}


if (dir=="UL" && !movingfoot && face=="N" && noteType==1)	{found=true; newface="N"; dir="DL";}
if (dir=="UL" && !movingfoot && face=="N" && noteType==3)	{found=true; newface="N"; dir="DR";}
if (dir=="UL" && !movingfoot && face=="N" && noteType==7)	{found=true; newface="N"; dir="UL";}
if (dir=="UL" && !movingfoot && face=="N" && noteType==9)   {found=true; newface="N"; dir="UR";}
if (dir=="UL" && !movingfoot && face=="N" && noteType==17)	{found=true; newface="WN"; dir="UD";}
if (dir=="UL" && !movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UL" && !movingfoot && face=="N" && noteType==2)	{found=true; newface="WN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UL" && !movingfoot && face=="N" && noteType==4)	{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UL" && !movingfoot && face=="N" && noteType==6)	{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UL" && !movingfoot && face=="N" && noteType==8)	{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="N" && noteType==1)		{found=true; newface="N"; dir="DL";}
if (dir=="UL" && movingfoot && face=="N" && noteType==3)		{found=true; newface="N"; dir="DR";}
if (dir=="UL" && movingfoot && face=="N" && noteType==7)		{found=true; newface="N"; dir="UL";}
if (dir=="UL" && movingfoot && face=="N" && noteType==9)	  	{found=true; newface="N"; dir="UR";}
if (dir=="UL" && movingfoot && face=="N" && noteType==17)  	{found=true; newface="WN"; dir="UD";}
if (dir=="UL" && movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UL" && movingfoot && face=="N" && noteType==2)	  	{found=true; newface="N"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="N" && noteType==4)		{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="N" && noteType==6)		{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="N" && noteType==8)		{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UL" && !movingfoot && face=="S" && noteType==1)	{found=true; newface="S"; dir="DL";}
if (dir=="UL" && !movingfoot && face=="S" && noteType==3)	{found=true; newface="S"; dir="DR";}
if (dir=="UL" && !movingfoot && face=="S" && noteType==7)	{found=true; newface="S"; dir="UL";}
if (dir=="UL" && !movingfoot && face=="S" && noteType==9)   {found=true; newface="N"; dir="UR";}
if (dir=="UL" && !movingfoot && face=="S" && noteType==17)	{found=true; newface="ES"; dir="UD";}
if (dir=="UL" && !movingfoot && face=="S" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UL" && !movingfoot && face=="S" && noteType==2)	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="UL" && !movingfoot && face=="S" && noteType==4)	{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UL" && !movingfoot && face=="S" && noteType==6)	{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="UL" && !movingfoot && face=="S" && noteType==8)	{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="S" && noteType==1)		{found=true; newface="S"; dir="DL";}
if (dir=="UL" && movingfoot && face=="S" && noteType==3)		{found=true; newface="S"; dir="DR";}
if (dir=="UL" && movingfoot && face=="S" && noteType==7)		{found=true; newface="S"; dir="UL";}
if (dir=="UL" && movingfoot && face=="S" && noteType==9)	  	{found=true; newface="N"; dir="UR";}
if (dir=="UL" && movingfoot && face=="S" && noteType==17)  	{found=true; newface="ES"; dir="UD";}
if (dir=="UL" && movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="UL" && movingfoot && face=="S" && noteType==2)	  	{found=true; newface="ES"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="S" && noteType==4)		{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="S" && noteType==6)		{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UL" && movingfoot && face=="S" && noteType==8)		{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}

if (dir=="UR" && !movingfoot && face=="N" && noteType==1)	{found=true; newface="N"; dir="DL";}
if (dir=="UR" && !movingfoot && face=="N" && noteType==3)	{found=true; newface="N"; dir="DR";}
if (dir=="UR" && !movingfoot && face=="N" && noteType==7)	{found=true; newface="N"; dir="UL";}
if (dir=="UR" && !movingfoot && face=="N" && noteType==9)   {found=true; newface="N"; dir="UR";}
if (dir=="UR" && !movingfoot && face=="N" && noteType==17)	{found=true; newface="EN"; dir="UD";}
if (dir=="UR" && !movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UR" && !movingfoot && face=="N" && noteType==2)	{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="UR" && !movingfoot && face=="N" && noteType==4)	{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="UR" && !movingfoot && face=="N" && noteType==6)	{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UR" && !movingfoot && face=="N" && noteType==8)	{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="N" && noteType==1)		{found=true; newface="N"; dir="DL";}
if (dir=="UR" && movingfoot && face=="N" && noteType==3)		{found=true; newface="N"; dir="DR";}
if (dir=="UR" && movingfoot && face=="N" && noteType==7)		{found=true; newface="N"; dir="UL";}
if (dir=="UR" && movingfoot && face=="N" && noteType==9)	  	{found=true; newface="N"; dir="UR";}
if (dir=="UR" && movingfoot && face=="N" && noteType==17)  	{found=true; newface="EN"; dir="UD";}
if (dir=="UR" && movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UR" && movingfoot && face=="N" && noteType==2)	  	{found=true; newface="EN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="N" && noteType==4)		{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="N" && noteType==6)		{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="N" && noteType==8)		{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UR" && !movingfoot && face=="S" && noteType==1)	{found=true; newface="S"; dir="DL";}
if (dir=="UR" && !movingfoot && face=="S" && noteType==3)	{found=true; newface="S"; dir="DR";}
if (dir=="UR" && !movingfoot && face=="S" && noteType==7)	{found=true; newface="S"; dir="UL";}
if (dir=="UR" && !movingfoot && face=="S" && noteType==9)   {found=true; newface="S"; dir="UR";}
if (dir=="UR" && !movingfoot && face=="S" && noteType==17)	{found=true; newface="WS"; dir="UD";}
if (dir=="UR" && !movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="UR" && !movingfoot && face=="S" && noteType==2)	{found=true; newface="WS"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UR" && !movingfoot && face=="S" && noteType==4)	{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UR" && !movingfoot && face=="S" && noteType==6)	{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UR" && !movingfoot && face=="S" && noteType==8)	{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="S" && noteType==1)		{found=true; newface="S"; dir="DL";}
if (dir=="UR" && movingfoot && face=="S" && noteType==3)		{found=true; newface="S"; dir="DR";}
if (dir=="UR" && movingfoot && face=="S" && noteType==7)		{found=true; newface="N"; dir="UL";}
if (dir=="UR" && movingfoot && face=="S" && noteType==9)	  	{found=true; newface="S"; dir="UR";}
if (dir=="UR" && movingfoot && face=="S" && noteType==17)  	{found=true; newface="WS"; dir="UD";}
if (dir=="UR" && movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="UR" && movingfoot && face=="S" && noteType==2)	  	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="S" && noteType==4)		{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="S" && noteType==6)		{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UR" && movingfoot && face=="S" && noteType==8)		{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}

if (dir=="DL" && !movingfoot && face=="N" && noteType==1)	{found=true; newface="N"; dir="DL";}
if (dir=="DL" && !movingfoot && face=="N" && noteType==3)	{found=true; newface="N"; dir="DR";}
if (dir=="DL" && !movingfoot && face=="N" && noteType==7)	{found=true; newface="N"; dir="UL";}
if (dir=="DL" && !movingfoot && face=="N" && noteType==9)   {found=true; newface="N"; dir="UR";}
if (dir=="DL" && !movingfoot && face=="N" && noteType==17)	{found=true; newface="EN"; dir="UD";}
if (dir=="DL" && !movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="DL" && !movingfoot && face=="N" && noteType==2)	{found=true; newface="WN"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && !movingfoot && face=="N" && noteType==4)	{found=true; newface="N"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && !movingfoot && face=="N" && noteType==6)	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DL" && !movingfoot && face=="N" && noteType==8)	{found=true; newface="EN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="N" && noteType==1)		{found=true; newface="N"; dir="DL";}
if (dir=="DL" && movingfoot && face=="N" && noteType==3)		{found=true; newface="N"; dir="DR";}
if (dir=="DL" && movingfoot && face=="N" && noteType==7)		{found=true; newface="N"; dir="UL";}
if (dir=="DL" && movingfoot && face=="N" && noteType==9)	  	{found=true; newface="N"; dir="UR";}
if (dir=="DL" && movingfoot && face=="N" && noteType==17)  	{found=true; newface="EN"; dir="UD";}
if (dir=="DL" && movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="DL" && movingfoot && face=="N" && noteType==2)	  	{found=true; newface="N"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="N" && noteType==4)		{found=true; newface="N"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="N" && noteType==6)		{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="N" && noteType==8)		{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="DL" && !movingfoot && face=="S" && noteType==1)	{found=true; newface="S"; dir="DL";}
if (dir=="DL" && !movingfoot && face=="S" && noteType==3)	{found=true; newface="S"; dir="DR";}
if (dir=="DL" && !movingfoot && face=="S" && noteType==7)	{found=true; newface="S"; dir="UL";}
if (dir=="DL" && !movingfoot && face=="S" && noteType==9)   {found=true; newface="S"; dir="UR";}
if (dir=="DL" && !movingfoot && face=="S" && noteType==17)	{found=true; newface="WS"; dir="UD";}
if (dir=="DL" && !movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="DL" && !movingfoot && face=="S" && noteType==2)	{found=true; newface="S"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && !movingfoot && face=="S" && noteType==4)	{found=true; newface="S"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && !movingfoot && face=="S" && noteType==6)	{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="DL" && !movingfoot && face=="S" && noteType==8)	{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="S" && noteType==1)		{found=true; newface="S"; dir="DL";}
if (dir=="DL" && movingfoot && face=="S" && noteType==3)		{found=true; newface="N"; dir="DR";}
if (dir=="DL" && movingfoot && face=="S" && noteType==7)		{found=true; newface="S"; dir="UL";}
if (dir=="DL" && movingfoot && face=="S" && noteType==9)	  	{found=true; newface="S"; dir="UR";}
if (dir=="DL" && movingfoot && face=="S" && noteType==17)  	{found=true; newface="WS"; dir="UD";}
if (dir=="DL" && movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="DL" && movingfoot && face=="S" && noteType==2)	  	{found=true; newface="S"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="S" && noteType==4)		{found=true; newface="S"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="S" && noteType==6)		{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DL" && movingfoot && face=="S" && noteType==8)		{found=true; newface="WS"; dir="UD"; movingfoot=1-movingfoot;}

if (dir=="DR" && !movingfoot && face=="N" && noteType==1)	{found=true; newface="N"; dir="DL";}
if (dir=="DR" && !movingfoot && face=="N" && noteType==3)	{found=true; newface="N"; dir="DR";}
if (dir=="DR" && !movingfoot && face=="N" && noteType==7)	{found=true; newface="N"; dir="UL";}
if (dir=="DR" && !movingfoot && face=="N" && noteType==9)   {found=true; newface="N"; dir="UR";}
if (dir=="DR" && !movingfoot && face=="N" && noteType==17)	{found=true; newface="WN"; dir="UD";}
if (dir=="DR" && !movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="DR" && !movingfoot && face=="N" && noteType==2)	{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && !movingfoot && face=="N" && noteType==4)	{found=true; newface="N"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="DR" && !movingfoot && face=="N" && noteType==6)	{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && !movingfoot && face=="N" && noteType==8)	{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="N" && noteType==1)		{found=true; newface="N"; dir="DL";}
if (dir=="DR" && movingfoot && face=="N" && noteType==3)		{found=true; newface="N"; dir="DR";}
if (dir=="DR" && movingfoot && face=="N" && noteType==7)		{found=true; newface="N"; dir="UL";}
if (dir=="DR" && movingfoot && face=="N" && noteType==9)	  	{found=true; newface="N"; dir="UR";}
if (dir=="DR" && movingfoot && face=="N" && noteType==17)  	{found=true; newface="WN"; dir="UD";}
if (dir=="DR" && movingfoot && face=="N" && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="DR" && movingfoot && face=="N" && noteType==2)	  	{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="N" && noteType==4)		{found=true; newface="S"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="N" && noteType==6)		{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="N" && noteType==8)		{found=true; newface="WN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="DR" && !movingfoot && face=="S" && noteType==1)	{found=true; newface="N"; dir="DL";}
if (dir=="DR" && !movingfoot && face=="S" && noteType==3)	{found=true; newface="S"; dir="DR";}
if (dir=="DR" && !movingfoot && face=="S" && noteType==7)	{found=true; newface="S"; dir="UL";}
if (dir=="DR" && !movingfoot && face=="S" && noteType==9)   {found=true; newface="S"; dir="UR";}
if (dir=="DR" && !movingfoot && face=="S" && noteType==17)	{found=true; newface="ES"; dir="UD";}
if (dir=="DR" && !movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="DR" && !movingfoot && face=="S" && noteType==2)	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && !movingfoot && face=="S" && noteType==4)	{found=true; newface="N"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="DR" && !movingfoot && face=="S" && noteType==6)	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && !movingfoot && face=="S" && noteType==8)	{found=true; newface="ES"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="S" && noteType==1)		{found=true; newface="S"; dir="DL";}
if (dir=="DR" && movingfoot && face=="S" && noteType==3)		{found=true; newface="N"; dir="DR";}
if (dir=="DR" && movingfoot && face=="S" && noteType==7)		{found=true; newface="S"; dir="UL";}
if (dir=="DR" && movingfoot && face=="S" && noteType==9)	  	{found=true; newface="S"; dir="UR";}
if (dir=="DR" && movingfoot && face=="S" && noteType==17)  	{found=true; newface="ES"; dir="UD";}
if (dir=="DR" && movingfoot && face=="S" && noteType==18)	{found=true; newface="S"; dir="LR";}
if (dir=="DR" && movingfoot && face=="S" && noteType==2)	  	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="S" && noteType==4)		{found=true; newface="S"; dir="LR"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="S" && noteType==6)		{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="DR" && movingfoot && face=="S" && noteType==8)		{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}

if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==1)	{found=true; newface="S"; dir="DL";}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==3)	{found=true; newface="N"; dir="DR";}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==7)	{found=true; newface="N"; dir="UL";}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==9)   {found=true; newface="S"; dir="UR";}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==17)	{found=true; newface="WN"; dir="UD";}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==2)	{found=true; newface="WN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==4)	{found=true; newface="N"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==6)	{found=true; newface="S"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UD" && !movingfoot && face[0]=='W' && noteType==8)	{found=true; newface="WN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==1) 	{found=true; newface="S"; dir="DL";}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==3) 	{found=true; newface="N"; dir="DR";}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==7) 	{found=true; newface="N"; dir="UL";}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==9)  	{found=true; newface="S"; dir="UR";}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==17)	{found=true; newface="WN"; dir="UD";}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==2)  	{found=true; newface="WN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==4) 	{found=true; newface="S"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==6) 	{found=true; newface="N"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='W' && noteType==8) 	{found=true; newface="WN"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==1)	{found=true; newface="N"; dir="DL";}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==3)	{found=true; newface="S"; dir="DR";}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==7)	{found=true; newface="S"; dir="UL";}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==9)   {found=true; newface="N"; dir="UR";}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==17)	{found=true; newface="ES"; dir="UD";}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==2)	{found=true; newface="ES"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==4)	{found=true; newface="N"; dir="DL"; movingfoot=1-movingfoot;}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==6)	{found=true; newface="S"; dir="DR"; movingfoot=1-movingfoot;}
if (dir=="UD" && !movingfoot && face[0]=='E' && noteType==8)	{found=true; newface="ES"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==1) 	{found=true; newface="N"; dir="DL";}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==3)		{found=true; newface="S"; dir="DR";}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==7)		{found=true; newface="S"; dir="UL";}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==9)  	{found=true; newface="N"; dir="UR";}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==17) 	{found=true; newface="ES"; dir="UD";}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==18)	{found=true; newface="N"; dir="LR";}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==2)  	{found=true; newface="ES"; dir="UD"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==4)  	{found=true; newface="S"; dir="UL"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==6)  	{found=true; newface="N"; dir="UR"; movingfoot=1-movingfoot;}
if (dir=="UD" && movingfoot && face[0]=='E' && noteType==8)  	{found=true; newface="ES"; dir="UD"; movingfoot=1-movingfoot;}

   //if going S-E/W-S make sure the E and S don't count for tech- W/E is neutral
	double temp=1;

   double techvalue=7;
   double nontech=0.2;

   if ((face=="N" || face=="EN" || face=="WN") &&
       (newface=="S" || newface=="ES" || newface=="WS"))
       temp=techvalue; //tech found
   if ((face=="S" || face=="ES" || face=="WS") &&
       (newface=="N" || newface=="EN" || newface=="WN"))
       temp=techvalue; //tech found
   face=newface;
   if (olddir==dir) temp=nontech; //un-tech (not moving)
   if (found)
	   return temp;
   else
   { //debug help
   	cout<<endl<<"ERROR! Transition not found!"<<endl<<"dir="<<dir<<" movingfoot="<<movingfoot
    	    <<" face="<<face<<" noteType="<<char(noteType+48)<<endl<<endl<<"Aborting.";
      getch(); abort();
   }
}
